unit OOP2;

interface

type
    TCircle        =object
                    procedure SetRadius(R:real);
                    function GetRadius:real;
                    function Area:real;
                    function Circumference:real;

                    private
                      Radius:real;
                    end;

    TSphere        =object(TCircle)
                    function Area:real;
                    function Volume:real;
                    end;

    TCylinder      =object(TCircle)
                    constructor SetHeight(H:real);
                    destructor Done;
                    function GetHeight:real;
                    function Area:real;
                    function BaseArea:real;virtual;
                    function Volume:real;

                    private
                      Height:real;
                    end;

    THollowCylinder=object(TCylinder)
                    constructor SetInnerRadius(R:real);
                    destructor Done;
                    function GetInnerRadius:real;
                    function Area:real;
                    function BaseArea:real;virtual;
                    private
                      InnerRadius:real;
                    end;

implementation

procedure TCircle.SetRadius(R:real);

begin
  Radius:=R
end;

function TCircle.GetRadius:real;

begin
  GetRadius:=Radius
end;

function TCircle.Area:real;

begin
  Area :=Pi*sqr(Radius);
end;

function TCircle.Circumference:real;

begin
  Circumference :=2*Pi*Radius
end;

function TSphere.Area:real;

begin
  Area :=4*TCircle.Area
end;

function TSphere.Volume:real;

begin
  Volume :=4/3*Pi*sqr(Radius)*Radius
end;

constructor TCylinder.SetHeight(H:real);

begin
  Height:=H;
end;

destructor TCylinder.Done;

begin
end;

function TCylinder.GetHeight:real;

begin
  GetHeight:=Height;
end;

function TCylinder.Area:real;

begin
  Area:=TCircle.Area+TCircle.Circumference*Height;
end;

function TCylinder.BaseArea:real;

begin
  BaseArea:=TCircle.Area
end;

function TCylinder.Volume:real;

begin
  Volume:=BaseArea*Height
end;

constructor THollowCylinder.SetInnerRadius(R:real);

begin
  InnerRadius:=R
end;

destructor THollowCylinder.Done;

begin
end;

function THollowCylinder.GetInnerRadius:real;

begin
  GetInnerRadius:=InnerRadius
end;

function THollowCylinder.Area:real;

begin
  Area:=BaseArea+TCircle.Circumference*Height
end;

function THollowCylinder.BaseArea:real;

begin
  BaseArea :=Pi*(sqr(Radius)-sqr(InnerRadius))
end;

end.
