program TVPian;

{********************************************}
{ Aplicatie la programarea orientata TVision }
{ Simularea functionarii unui pian simplu    }
{ Sunt utilizate :                           }
{      -Conceptul de vizor derivat din TView }
{      -Conceptul de fereastra               }
{      -Conceptul de boxa de dialog multi-   }
{       functionala.                         }
{      -Conceptul de eveniment               }
{********************************************}

uses crt,App,DriVers,Menus,Objects,Views,Dialogs,Validate;

const
  cmInfo     =100;
  cmPianNou  =110;
  cmOptiuni  =120;
  cmClapa    =1000;
  sfSunet    =$1000;

  Note     :array[0..7] of string[3]=
  ('D O','R E','M I','F A','SOL','L A','S I','D O');

  Taste    :array[0..7] of word     =
  (kbAlt1,kbAlt2,kbAlt3,kbAlt4,kbAlt5,kbAlt6,kbAlt7,kbAlt8);

  Frecvente:array[0..2,0..7] of word=
  ((262,294,330,350,392,440,494,524),
   (524,588,660,700,784,880,988,1048),
   (1048,1176,1320,1400,1568,1760,1976,2096));


type

  TDatePian=record
              CulClapa:boolean;
              CulNota:boolean;
              Gama   :byte;
              LNota  :word;
            end;


  PClAPA  =^TClapa;
  TClapa  =object(TView)
             Index:byte;
             Nota :PString;
             Tasta:word;
             constructor Init(var L:TRect;I:byte;N:string;T:word);
             destructor Done;virtual;
             procedure Draw;virtual;
             procedure HandleEvent(var Event:TEvent);virtual;
           end;

  PPian   =^TPian;
  TPian   =object(TWindow)
             constructor Init;
             destructor Done;virtual;
             procedure HandleEvent(var Event:TEvent);virtual;
           end;


  TPianApp=object(TApplication)
             constructor Init;
             procedure InitMenuBar;virtual;
             procedure InitStatusLine;virtual;
             procedure HandleEvent(var Event:TEvent);virtual;
           end;

var
  Pian    :TPianApp;
  DatePian:TDatePian;

constructor TClapa.Init(var L:TRect;I:byte;N:string;T:word);

begin
  inherited Init(L);
  EventMask:=EventMask or evMessage;
  Options  :=Options or ofFirstClick or ofFramed;
  Index    :=I;
  Nota     :=NewStr(N);
  Tasta    :=T;
end;

destructor TClapa.Done;

begin
  DisposeStr(Nota);
  inherited Done;
end;

procedure TClapa.Draw;

var
  Buffer        :array[0..20] of word;
  clClapa,clNota:byte;
  idClapa,idNota:byte;

begin
  idClapa:=6;
  idNota :=6;

  if GetState(sfSunet)
     then
     begin
       if DatePian.CulClapa then idClapa:=7;
       if DatePian.CulNota  then idNota :=7;
     end;

  clClapa:=GetColor(idClapa);
  clNota :=GetColor(idNota);

  MoveChar(Buffer,' ',clClapa,21);
  MoveStr(Buffer[9],Nota^,clNota);
  WriteBuf(0,0,Size.X,Size.Y,Buffer);
end;

procedure TClapa.HandleEvent(var Event:TEvent);

begin
  inherited HandleEvent(Event);
  if (Event.What   =evBroadcast) and
     (Event.Command=cmClapa)
     then
     begin
       if Event.InfoWord=Tasta
          then
          begin
            SetState(sfSunet,True);
            DrawView;
            Sound(Frecvente[DatePian.Gama,Index]);
            Delay(DatePian.LNota);
            NoSound;
            SetState(sfSunet,false);
            DrawView;
          end
          else
          exit;
       ClearEvent(Event);
     end
     else
     if Event.What=evMouseDown
        then
        begin
            SetState(sfSunet,True);
            DrawView;
            Sound(Frecvente[DatePian.Gama,Index]);
            repeat
            until not(MouseEvent(Event,evMouseDown or evMouseMove)
                  and MouseInView(Event.Where));

            NoSound;
            SetState(sfSunet,false);
            DrawView;
        end;
end;


constructor TPian.Init;

var
  L:TRect;
  I:byte;
  C:PClapa;

begin
  L.Assign(0,0,65,5);
  inherited Init(L,'',wnNoNumber);
  DragMode:=0;
  Options :=Options or ofCentered;
  DisableCommands([cmPianNou]);
  with L do
  begin
    A.Y:=1;
    B.Y:=4;
    for I:=0 to 7 do
    begin
      A.X:=8*I+1;
      B.X:=A.X+7;
      C  :=New(PClapa,Init(L,I,Note[I],Taste[I]));
      Insert(C);
    end;
  end;
end;

destructor TPian.Done;

begin
  EnableCommands([cmPianNou]);
  inherited Done;
end;

procedure TPian.HandleEvent(var Event:TEvent);
begin
  inherited HandleEvent(Event);
  if (Event.What    =evKeyDown) and
     (Event.CharCode=#0)
     then
     if Message(@Self,evBroadcast,cmClapa,Ptr(0,Event.KeyCode))<>nil
        then
        ClearEvent(Event);

end;

constructor TPianApp.Init;

begin
  inherited Init;
  with DatePian do
  begin
    CulClapa:=false;
    CulNota :=false;
    Gama    :=1;
    LNota   :=100;
  end;
end;

procedure TPianApp.InitMenuBar;

var
  L:TRect;
begin
  GetBounds(L);
  L.B.Y:=Succ(L.A.Y);
  MenuBar:=new(PMenuBar,init(L,NewMenu(
           NewSubMenu('~'#240'~',hcNoContext,
             NewMenu(
               NewItem('~I~nfo...','',kbNoKey,cmInfo,hcNoContext,
               NewLine(
               NewItem('~E~xit','Alt-X',kbAltX,cmQuit,hcNoContext,
               nil)))),
           NewSubMenu('~P~ian',hcNoContext,
             NewMenu(
               NewItem('~N~ou','F3',kbF3,cmPianNou,hcNoContext,
               NewItem('~O~ptiuni','',kbNoKey,cmOptiuni,hcNoContext,
               nil))),
           nil)))
           ));
end;

procedure TPianApp.InitStatusLine;

var
  L:TRect;

begin
  GetBounds(L);
  L.A.Y:=Pred(L.B.Y);
  StatusLine:=New(PStatusLine,Init(L,
    NewStatusDef(0,$FFFF,
      NewStatusKey('~F3~ Pian',kbF3,cmPianNou,
      NewStatusKey('~F10~ Meniu',kbF10,cmMenu,
      NewStatusKey('~Alt+F3~ Inchide fereastra',kbAltF3,cmClose,
      NewStatusKey('~Alt+X~ Sfirsit program',kbAltX,cmQuit,
      nil)))),
    nil)
  ));
end;

procedure TPianApp.HandleEvent(var Event:TEvent);

procedure Info;

var
  B:PButton;
  D:PDialog;
  L:TRect;
  T:PStaticText;

begin
  L.Assign(0,0,21,9);
  D:=New(PDialog,Init(L,''));
  with D^ do
  begin
    Options:=Options or ofCentered;
    L.Assign(1,2,20,5);

    T:=New(PStaticText,Init(L,#3'P I A N'#13#13+#3'versiunea 1.0'));
    Insert(T);

    L.Assign(4,6,17,8);
    B:=New(PButton,Init(L,'Press Enter',cmOk,bfDefault));
    Insert(B);
  end;
  ExecuteDialog(D,nil);
end;


procedure Optiuni;

type

  TOptDate=record
             LNota :string[4];
             Gama  :word;
             Culori:word;
           end;

var
  C:PView;
  D:PDialog;
  E:integer;
  L:TRect;
  V:TOptDate;

begin

  L.Assign(0,0,35,12);
  D:=New(PDialog,Init(L,'Optiuni...'));
  with D^ do
  begin
    Options:=Options or ofCentered;
    L.Assign(25,2,31,3);
    C:=New(PInputLine,Init(L,4));
    PInputLine(C)^.SetValidator(New(PRangeValidator,Init(1,1000)));
    Insert(C);

    L.Assign(3,2,25,3);
    Insert(New(PLabel,Init(L,'~L~ungime note (in ms)',C)));
    L.Assign(4,5,17,8);

    C:=New(PRadioButtons,Init(L,
           NewSItem('~J~oasa',
           NewSItem('~N~ormala',
           NewSItem('~I~nalta',
           nil)))
       ));
    Insert(C);

    L.Assign(3,4,8,5);
    Insert(New(PLabel,Init(L,'~G~ama',C)));
    L.Assign(20,5,31,7);
    C:=New(PCheckBoxes,Init(L,
           NewSItem('Cla~p~a',
           NewSItem('N~o~ta',
           nil))
       ));
    Insert(C);

    L.Assign(19,4,27,5);
    Insert(New(PLabel,Init(L,'~C~uloare',C)));

    L.Assign(3,9,16,11);
    Insert(New(PButton,Init(L,'O~k~',cmOk,bfDefault)));

    L.Assign(19,9,32,11);
    Insert(New(PButton,Init(L,'~C~ancel',cmCancel,bfNormal)));
  end;

  Str(DatePian.LNota,V.LNota);
  V.Gama  :=DatePian.Gama;
  V.Culori:=0;
  if DatePian.CulClapa
     then V.Culori:=1;
  if DatePian.CulNota
     then Inc(V.Culori,2);
  if ExecuteDialog(D,@V)=cmOk
     then
     begin
       Val(V.LNota,DatePian.LNota,E);
       DatePian.Gama    :=V.Gama;
       DatePian.CulClapa:=V.Culori and 1 <> 0;
       DatePian.CulNota :=V.Culori and 2 <> 0;
     end;
end;


procedure PianNou;
var
  P:PPian;
begin
  P:=New(PPian,Init);
  InsertWindow(P);
end;

begin
  inherited HandleEvent(Event);
  if Event.What=evCommand
     then
     begin
       case Event.Command of
       cmInfo   :Info;
       cmPianNou:PianNou;
       cmOptiuni:Optiuni
       else exit;
       end;
     end;
end;




begin
  Pian.Init;
  Pian.Run
  Pian.Done;
end.